const OracleService = require('../service/OracleService');

class parametrizacoesModel {
  constructor() {
    this.GET_ALL = `
      SELECT * FROM PORTAL ORDER BY ORDEM, NOME
    `;

    this.GET_ASS_CONFIG = `
      SELECT ID, NOME, DESCRICAO, TIPO, ORDEM, ATIVO, COMANDO, INTERVALO
        FROM ASSISTANT_CONFIG 
    ORDER BY ORDEM, NOME
    `;

    this.GET_ASS_CONFIG_ACTIVE = `
      SELECT ID, NOME, DESCRICAO, TIPO, ORDEM, ATIVO, COMANDO, INTERVALO
        FROM ASSISTANT_CONFIG 
       WHERE ATIVO = 'S'
    ORDER BY ORDEM, NOME
    `;

    this.UPDATE_ASS_CONFIG = `
      UPDATE ASSISTANT_CONFIG
         SET NOME      = :NOME,
             DESCRICAO = :DESCRICAO,
             TIPO      = :TIPO,
             ORDEM     = :ORDEM,
             ATIVO     = :ATIVO,
             COMANDO   = :COMANDO,
             INTERVALO = :INTERVALO
       WHERE ID = :ID
    `;

    this.INSERT_ASS_CONFIG = `
      INSERT INTO ASSISTANT_CONFIG (NOME, DESCRICAO, TIPO, ORDEM, COMANDO, INTERVALO)
                            VALUES (:NOME, :DESCRICAO, :TIPO, :ORDEM, :COMANDO, :INTERVALO)
    `;

    this.DELETE_ASS_CONFIG = `
      DELETE 
        FROM ASSISTANT_CONFIG
       WHERE ID IN (:ID)
    `;
  }

  get() {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_ALL);
    });
  }

  getAssConfig(activeOnly = false) {
    return OracleService.connect().then(() => {
      const sql = activeOnly ? this.GET_ASS_CONFIG_ACTIVE : this.GET_ASS_CONFIG;
      return OracleService.execute(sql);
    });
  }

  updateAssConfig(params) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.UPDATE_ASS_CONFIG, params);
    });
  }

  insertAssConfig(params) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.INSERT_ASS_CONFIG, params);
    });
  }

  deleteAssConfig(params) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.DELETE_ASS_CONFIG.replace(':ID', params.ID));
    });
  }
}

module.exports = new parametrizacoesModel();
